package com.example.elasticsearch.elasticsearchdemo.controller

import com.example.elasticsearch.elasticsearchdemo.model.Bank
import com.fasterxml.jackson.module.kotlin.isKotlinClass
import com.fasterxml.jackson.module.kotlin.jacksonObjectMapper
import java.net.InetAddress
import org.springframework.stereotype.Controller
import org.springframework.ui.Model
import org.elasticsearch.common.transport.TransportAddress
import org.elasticsearch.client.transport.TransportClient
import org.elasticsearch.transport.client.PreBuiltTransportClient
import org.elasticsearch.common.settings.Settings
import org.elasticsearch.action.search.SearchResponse
import org.elasticsearch.action.search.SearchType
import org.elasticsearch.client.RestClient
import org.elasticsearch.client.RestHighLevelClient
import org.elasticsearch.index.query.QueryBuilders
import org.elasticsearch.search.SearchHits
import org.elasticsearch.search.aggregations.AggregationBuilders
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.data.elasticsearch.client.ClientConfiguration
import org.springframework.data.elasticsearch.core.ElasticsearchOperations
import org.springframework.data.elasticsearch.core.query.GetQuery
import org.springframework.web.bind.annotation.*
import kotlin.reflect.jvm.internal.impl.metadata.ProtoBuf

@RestController
@RequestMapping("v1")
class APIController {

    @GetMapping("hello")
    fun hello(): String{
        return """
            "{"result":"Hello world" }"
        """
    }

    @GetMapping("/search/{keyword}")
    fun index(@PathVariable("keyword")keyword: String): SearchResponse {
        val settings: Settings = Settings.builder().put("cluster.name","docker-cluster").build()
        val client:TransportClient = PreBuiltTransportClient(Settings.EMPTY)
                .addTransportAddress(TransportAddress(InetAddress.getByName("localhost"), 9300))


        val response:SearchResponse = client.prepareSearch("bank")
                .setSearchType(SearchType.QUERY_THEN_FETCH)
                .setQuery(
                        QueryBuilders.boolQuery()
                                .should(QueryBuilders.termQuery("account_number", keyword))
                                .should(QueryBuilders.termQuery("address",keyword))
                                .should(QueryBuilders.termQuery("age",keyword))
                                .should(QueryBuilders.termQuery("balance",keyword))
                                .should(QueryBuilders.termQuery("city",keyword))
                                .should(QueryBuilders.termQuery("email",keyword))
                                .should(QueryBuilders.termQuery("employer",keyword))
                                .should(QueryBuilders.termQuery("firstname",keyword))
                                .should(QueryBuilders.termQuery("gender",keyword))
                                .should(QueryBuilders.termQuery("lastname",keyword))
                                .should(QueryBuilders.termQuery("state",keyword))
                )
                .setFrom(0).setSize(10).setExplain(true)
                .get()

        println(response.hits)
        println(response.hits.hits)

        return response

    }



}